﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using Microsoft.Toolkit.Win32.UI.Controls.Interop.WinRT;

using vistaWeb;

namespace vistaWeb
{
    public partial class Form1 : Form
    {

        //public string html;

        public Form1()
        {
            InitializeComponent();
        }

        //Métodos de WebView: Navigate("url"), GoBack(), GoForward(), Stop() y Refresh()

        private void Form1_Load(object sender, EventArgs e)
        {
            webView1.Navigate("https://www.google.es/");
        }

        private void AtrásToolStripMenuItem_Click(object sender, EventArgs e)
        {
            webView1.GoBack();
        }

        private void AdelanteToolStripMenuItem_Click(object sender, EventArgs e)
        {
            webView1.GoForward();
        }

        private void PararLaCargaDeLaPáginaToolStripMenuItem_Click(object sender, EventArgs e)
        {
            webView1.Stop();
        }

        private void RecargarLaPáginaToolStripMenuItem_Click(object sender, EventArgs e)
        {
            webView1.Refresh();
        }

        private void SalirToolStripMenuItem_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void GoogleToolStripMenuItem_Click(object sender, EventArgs e)
        {
            webView1.Navigate("https://www.google.es/?gws_rd=ssl");
        }

        private void BingToolStripMenuItem_Click(object sender, EventArgs e)
        {
            webView1.Navigate("https://www.bing.com/?setlang=es/");
        }

        private void YahooToolStripMenuItem1_Click(object sender, EventArgs e)
        {
            webView1.Navigate("https://es.yahoo.com/?guccounter=1");
        }

        private void Perez987ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            webView1.Navigate("https://perez987.es/");
        }

        private void VisualStudioToolStripMenuItem_Click(object sender, EventArgs e)
        {
            webView1.Navigate("https://visualstudio.microsoft.com/es/?rr=https%3A%2F%2Fwww.google.es%2F");
        }

        private void CToolStripMenuItem_Click(object sender, EventArgs e)
        {
            webView1.Navigate("https://docs.microsoft.com/es-es/visualstudio/get-started/csharp/?view=vs-2019");

        }

        //Método que se ejecuta al comenzar la navegación a contenido nuevo
        //private void WebView1_NavigationStarting(object sender, Microsoft.Toolkit.Win32.UI.Controls.Interop.WinRT.WebViewControlNavigationStartingEventArgs e)
        private void WebView1_NavigationStarting(object sender, WebViewControlNavigationStartingEventArgs e)
        {
            //mostrar la URL de la página que se visita en el TextBox
            var sitio = e.Uri.ToString();
            textUrl.Text = sitio;
        }

        //Método que se ejecuta al terminar la navegación a contenido nuevo
        //private void WebView1_NavigationCompleted(object sender, Microsoft.Toolkit.Win32.UI.Controls.Interop.WinRT.WebViewControlNavigationCompletedEventArgs e)
        //private void webView1_NavigationCompleted(object sender, WebViewNavigationCompletedEventArgs e)
        private  void WebView1_NavigationCompleted(object sender, WebViewControlNavigationCompletedEventArgs e)
        {
            //mostrar la URL de la página que se visita en el TextBox
            var sitio = e.Uri.ToString();
            textUrl.Text = sitio;           
        }

        //ir a la URL seleccionada en el ComboBox
        private void Button1_Click(object sender, EventArgs e)
        {
            //si textUrl  comienza por http o https o www y no está vacío ni es página en blanco
            if (string.IsNullOrEmpty(System.Convert.ToString(textUrl.Text)))
            {
                return;
            }
            if (textUrl.Text.Equals("about:blank"))
            {
                return;
            }
            if (!textUrl.Text.StartsWith("http://") && !textUrl.Text.StartsWith("https://") && !textUrl.Text.StartsWith("www."))
            {
                return;
            }
            webView1.Navigate(textUrl.Text);
        }

        //abrir el formulario con el código fuente HTML de la página que se visita
        private async void CodeHTMLToolStripMenuItem_ClickAsync(object sender, EventArgs e)
        {
            //obtener el código HTML de la página con JavaScript, WebView no tiene métodos propios para ello
            string html = await webView1.InvokeScriptAsync("eval", new string[] { "document.documentElement.outerHTML;" });
            //MessageBox.Show(html.Substring(0, 512));  //mensaje de comprobación
            //declarar instancia del otro formulario y asignar la cadena html a su propiedad Texto
            Form2 f2 = new Form2
            {
                Texto = html
            };
            //mostrar Form2
            f2.ShowDialog();
        }      

    }
}
